"""
========================================
  Introduction to Computer Programming
========================================

-----------------------------------------------
  Lab 9
  lists

  (starter file - remove this line once edited)
  <YOUR NAMES GO HERE>
-----------------------------------------------
"""

# uncomment these imports as needed:
#
# from time import sleep
#
# from lab9_examples import random_list
# from mini_graphics import clear, paint, update, ROWS


# 0. warmup: just like decrement_list in examples file
def increment_list(a):
    """Adds one to every number in list a.

    >>> ns = [44, 66, 55]
    >>> increment_list(ns)
    >>> ns
    [45, 67, 56]
    """
    ...


# 1. warmup: very much like append_first in example file
def copy_last(a):
    """Adds a copy of last item onto end of list a. Assumes a is not empty.

    >>> stuff = ['Cool!', False, 37]
    >>> copy_last(stuff)
    >>> stuff
    ['Cool!', False, 37, 37]
    """
    ...


# 2. use for/range and .append
def build_zero_array(n):
    """Return list of zeroes of length n.

    >>> build_zero_array(5)
    [0, 0, 0, 0, 0]
    """
    a = []
    ...
    return a


# 3. calls build_zero_array
def letter_count(s):
    """
    Returns a list indicating how many of each uppercase letter occurs in
    string s. The position in the list corresponds to which letter (the number
    of 'A's is at index 0, 'B's at index 1, up to 'Z's at index 25)

    >>> letter_count('WHAT IS THE FREQUENCY, kennetH?')
    [1, 0, 1, 0, 3, 1, 0, 3, 1, 0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 2, 1, 0, 1, 0, 1, 0]
    """
    ...
    for c in s:
        d = ord(c) - ord('A')    # generates a number between 0 and 26
        ...
    return ...


# 4. use for/range and mutable list assignment
def apply(f, a):
    """
    Applies function f to each element of list a. Assumes f is a function that
    takes exactly one argument.

    >>> def foo(x): return x + 2
    >>> ns = [25, 13, 36]
    >>> apply(foo, ns)
    >>> ns
    [27, 15, 38]
    """
    ...


# 5. look at insert_at in example file as a (loose) model
#    use pop
def remove_from(a, i):
    """
    Removes and returns element at position i in list a.
    Assumes 0 <= i < len(x).

    >>> stuff = ['alpha', 'delta', 'gamma', 'beta']
    >>> remove_from(stuff, 1)
    'delta'
    >>> stuff
    ['alpha', 'gamma', 'beta']
    >>> remove_from(stuff, 2)
    'beta'
    >>> stuff
    ['alpha', 'gamma']
    >>> remove_from(stuff, 0)
    'alpha'
    >>> remove_from(stuff, 0)
    'gamma'
    >>> len(stuff)
    0
    """
    removed = a[i]
    ...
    return removed


# 6. pay close attention to descrption and examples:
def insert_in_order(a, stop, x):
    """
    Inserts x into list a between indexes 0 (inclusive) and stop (exclusive) so
    as to maintain sorted order (between positions 0 and stop). Assumes stop is
    less than len(a) and that a is already in increasing order from positions 0
    to stop.

    >>> ns = [99, 99, 99, 99]
    >>> insert_in_order(ns, 1, 16)
    >>> ns
    [16, 99, 99, 99]
    >>> insert_in_order(ns, 2, 45)
    >>> ns
    [16, 45, 99, 99]
    >>> insert_in_order(ns, 3, 23)
    >>> ns
    [16, 23, 45, 99]
    """
    i = stop
    while ... and ...:
        ...
        i -= 1
    a[i] = x


# 7. call insert_in_order in body of for/range
def insertion_sort(a):
    """Sorts elements of a in increasing order using insertion sort.

    >>> ns = [17, 3, 11, 19, 5, 7, 13]
    >>> insertion_sort(ns)
    >>> ns
    [3, 5, 7, 11, 13, 17, 19]
    """
    ...


# 8. remember to call update at end
def visualize_list(a):
    """
    Draws elements of list at (x, y) where x is the index of element y. Assumes
    len(a) is no more than COLUMNS and that elements are integers between 0
    (inclusive) and ROWS (exclusive). List should appear all at once in
    graphics window.
    """
    clear()
    ...


# 9. call visualize_list; sort anyway you like (selection, bubble, insertion)
#    use sleep as needed
def visual_sort():
    """
    Builds a list of random numbers that fits in mini graphics window.
    Creates visual representation of list as it is being sorted.
    """
    ns = random_list(ROWS)
    ...
